//BSESensex js v1.1
// added basic error handeling
// the extension now decides how soon should it try updating the value, if at all
// Market value was being fecthed from browser cache, hence a bit stale. Should be fixed now.
//Author Priyank Bolia
var myTimer=0;
var status=0;
var IndiaMarket = {
	// Install a timeout handler to install the interval routine

	startup: function()
	{
		var ret;
		this.refreshInformation();
	},

	// Called periodically to refresh the stock information
	refreshInformation: function  ()
	{
		var ret=0;
		IndiaMarket.contactServer();
	},
	
	contactServer: function()
	{
		loading();
		var dtmNow = new Date();
		var httpRequest = null;
		var fullUrl = "http://www.sharekhan.com/News/CompanyBasicQuote.aspx" + "?sskicode=" + "SENSEX";
			
		function infoReceived()
		{
			
			var samplePanel = document.getElementById('indiamarket');
			var output = httpRequest.responseText;
			var retStatus=httpRequest.status;
			
			switch (retStatus)
			{
			case 200:
				//all OK
				if (output.length)
				{
					var re = new RegExp("<span id=\"BasicQuote1_lblBse1\">([0-9.]*)</span>");
					var m = re.exec(output);
					if (m == null) {
					} else {
					  for (i = 0; i < m.length; i++) {
					    s = m[i];
					  }
					  samplePanel.label = "BSE: " + s;
					}
					
					samplePanel.tooltipText = "BSESensex: Priyank Bolia <soft@priyank.in>";
					status=retStatus;
					if (myTimer>0)
					{
						clearInterval(myTimer);
					}
					myTimer=window.setInterval(IndiaMarket.refreshInformation, 30*60*1000);
					break;
				}
				break;
			case 403:
				//forbidden
				var samplePanel = document.getElementById('indiamarket');
				samplePanel.label ="Oops!";
				samplePanel.tooltipText ="Access was denied to the ShareKhan server! Please check with your network admin. Click to retry.";
				status=retStatus;
				break;
			default:
				var samplePanel = document.getElementById('indiamarket');
				samplePanel.label ="Oops!";
				samplePanel.tooltipText ="The update server seems to be unavailable. Update will be attempted again later";
				status=retStatus;
					if (myTimer>0)
					{
						clearInterval(myTimer);
					}
					myTimer=window.setInterval(IndiaMarket.refreshInformation, 5*60*1000);
				break;
			}
			
		}
		
		function loading()
		{
				var samplePanel = document.getElementById('indiamarket');
				samplePanel.label ="Updating...";
				samplePanel.tooltipText ="Attempting update of data...";
		}
		
		httpRequest = new XMLHttpRequest();
		
		httpRequest.open("GET", fullUrl, true);
		httpRequest.onload = infoReceived;
		
		try {
			httpRequest.send(null);
		}
		catch (e) {
			var samplePanel = document.getElementById('indiamarket');
			samplePanel.label ="Error!";
			samplePanel.tooltipText ="Could not contact the server at this time. Is your internet configuration OK?";
		}
		
	}
}

// Install load handler

window.addEventListener("load", function(e) { IndiaMarket.startup(); }, false);
